<template>
  <ATablePage
    ref="tablePage"
    v-bind="tablePageProps">
    <template #simpleFormItem="formData">
      <ElFormItem>
        <ElInput v-model="formData.customerId" placeholder="管理员名称"/>
      </ElFormItem>
      <ElFormItem>
        <ElInput v-model="formData.orgId" placeholder="企业名称"/>
      </ElFormItem>
      <ElFormItem>
        <ElInput v-model="formData.expenseItemName" placeholder="费用名称"/>
      </ElFormItem>
    </template>

    <template #columns>
      <ElTableColumn label="管理员名称" prop="userId"/>
      <ElTableColumn label="企业名称" prop="customerId"/>
      <ElTableColumn label="费用类型" prop="expenseItemCategory"/>
      <ElTableColumn label="付费项名称" prop="expenseItemName"/>
      <ElTableColumn label="计费策略" prop="expenseStrategy"/>
      <ElTableColumn label="计量单位" prop="unit"/>
      <ElTableColumn label="税率" prop="taxRate"/>
      <ElTableColumn label="单价" prop="unitPrice"/>
      <ElTableColumn label="起步价" prop="initialPrice"/>
      <ElTableColumn label="起步量" prop="initialQuantity"/>
      <ElTableColumn label="每档的量" prop="everyQuantity"/>
      <ElTableColumn label="是否可用" prop="canuse"/>
      <ElTableColumn label="备注" prop="memo"/>
    </template>
    <ExpenseItemForm ref="expenseItemForm" :research="research"/>
    <ExpenseItemDetail ref="expenseItemDetail"/>
  </ATablePage>
</template>

<script lang="ts" setup>
import ExpenseItemApi from '@/pages/fin/expense-item/expense-item-api.ts'
import ExpenseItemForm from '@/pages/fin/expense-item/ExpenseItemForm.vue'
import ExpenseItemDetail from '@/pages/fin/expense-item/ExpenseItemDetail.vue'
import ATablePage, {
  type ATablePageInstance,
  buildTablePageProps,
} from '@/components/a-page/a-table-page/ATablePage.tsx'

const tablePageIns = useTemplateRef<ATablePageInstance>('tablePage')
const expenseItemFormIns = useTemplateRef<InstanceType<typeof ExpenseItemForm>>('expenseItemForm')
const expenseItemDetailIns = useTemplateRef<InstanceType<typeof ExpenseItemDetail>>('expenseItemDetail')

function research() {
  tablePageIns.value?.doSearch()
}

const tablePageProps = buildTablePageProps<ExpenseItemTypes.SearchExpenseItemParam, ExpenseItemTypes.SearchExpenseItemResult>({
  pageLayout: {
    enableHighForm: false,
  },
  searchForm: {
    paging: ExpenseItemApi.paging,
  },
  toolBar: {
    leftTools: [
      {
        icon: 'Plus',
        label: '新建',
        action() {
          expenseItemFormIns.value?.open()
        },
      },
    ],
  },
  table: {
    actionColumn: {
      tableActions: [
        {
          tooltip: '详情',
          icon: 'Postcard',
          type: 'info',
          action({row}) {
            expenseItemDetailIns.value?.open(row)
          },
        },
        {
          tooltip: '编辑',
          icon: 'Edit',
          type: 'primary',
          action({row}) {
            expenseItemFormIns.value?.open(row)
          },
        },
        {
          icon: 'Delete',
          loading: false,
          type: 'danger',
          tooltip: '删除',
          confirm: {
            title: '是否删除当前数据',
          },
          action({row}) {
            return ExpenseItemApi.del([ row.id! ])
              .then(() => {
                ElMessage.success('删除成功')
                return true
              })
          },
        },
      ],
    },
  },
})

</script>
